----------------------------------------------------------------------------------
--  
--        fm_det_cordic.vhd        FMg( CORDICŕΊpvZAĎgvZ )
--  
--        (c)2011/06/06  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
--  ƓIp͂߂B
--  
--  
--
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                      193  out of   1792    10%  
-- Number of Slice Flip Flops:            111  out of   3584     3%  
-- Number of 4 input LUTs:                366  out of   3584    10%  
-- Number of IOs:                          52
-- Number of bonded IOBs:                  51  out of     68    75%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 10.197ns (Maximum Frequency: 98.066MHz)
--   Minimum input arrival time before clock: 7.333ns
--   Maximum output required time after clock: 5.531ns
--   Maximum combinational path delay: No path found
--
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

Library UNISIM;
use UNISIM.vcomponents.all;

------------------------------------------------------------------------------
entity fm_det_cordic is 
  port (
    RESET   : in  std_logic;                       -- 
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 15 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 15 downto 0 ); -- Q M
    DET_OUT : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    OD      : out std_logic                        -- o̓f[^L
  );
end fm_det_cordic;


------------------------------------------------------------------------------
architecture RTL of fm_det_cordic is
  
  signal ARG    : std_logic_vector( 15 downto 0 ); -- 
  signal ARG_Z1 : std_logic_vector( 15 downto 0 ); -- 
  signal OD_CORDIC : std_logic; -- 
  signal CNT    : std_logic_vector(  2 downto 0 ); -- 
  
  component cordic
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- ̓f[^L
    X_IN    : in  std_logic_vector( 15 downto 0 ); -- 
    Y_IN    : in  std_logic_vector( 15 downto 0 ); -- 
    ABS_OUT : out std_logic_vector( 15 downto 0 ); -- Βló@1.6467602581{Ă
    ARG_OUT : out std_logic_vector( 15 downto 0 ); -- argiΊpjo
    OD      : out std_logic                        -- o̓f[^L
  );
  end component;
  
  
  
begin
  
  u0 : cordic
  port map (
    CLK     => CLK,           -- 
    ND      => ND,            -- ̓f[^L
    X_IN    => I_IN,          -- 
    Y_IN    => Q_IN,          -- 
    ABS_OUT => open,          -- Βló@1.6467602581{Ă
    ARG_OUT => ARG,           -- argiΊpjo
    OD      => OD_CORDIC      -- o̓f[^L
  );
  
  
  ------------------------------------------------------------------
  --    CORDIC ŌvZΊpg𓾂
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( OD_CORDIC='1' ) then                       -- f[^
        DET_OUT <= ARG - ARG_Z1;
        ARG_Z1  <= ARG;
        OD      <= '1';
      else
        OD <= '0';
      end if;
    end if;
  end process;
  
end RTL;
----------------------------- end of architecture ----------------------------

